
#include "control/specifications.h"

float speedController(float *speed_desired, float speed_current, float speed_integral, float heading_error)
{
  float v_des=0.4;  //CHange max desired velocity here. TODO: Better method? 
  float speed_des;
  float speed_error;

  //Find desired speed based on heading error (large error, smaller speed desired)
  if (abs(heading_error) <= PI/2)
  {
    speed_des=-(v_des/(PI/2))*abs(heading_error)+v_des;
  }
  else
  {
    speed_des=0;
  }

  speed_error=speed_current-speed_des;

  float K_p, K_i;
  K_p=10000;
  K_i=1;
  float x_control;
  float P_control=K_p*speed_error;
  float I_control=K_i*speed_integral;


  x_control=-P_control-I_control;
  *speed_desired=speed_des;

  return x_control;
}
