
#include "control/specifications.h"

float depthController(float depth_desired, float depth_current, float depth_integral)
{
  float P_gain=1000;
  float I_gain=5;

  //Find depth error
  double depthError=depth_current-depth_desired;

  float P_control=depthError*P_gain;
  float I_control=depth_integral*I_gain;
  float depth_control=-P_control-I_control;

  return depth_control;
}
