#include "dynamics/specifications.h"


Matrix3f rotationMatrixQ(const Matrix<float, 4, 1>& quaternions)
{

  Vector3f epsilon(quaternions(1), quaternions(2), quaternions(3));
  Matrix3f epsilon_skew, R_q;


  epsilon_skew=skewSymmetric(epsilon);
  
  R_q=Matrix3f::Identity()+2*quaternions(0)*epsilon_skew+2*epsilon_skew*epsilon_skew;


  return R_q;
}
